package app;

import model.AlarmList;
import view.AlarmListFrame;

import java.io.File;
import java.io.FileOutputStream;
import java.util.List;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;
import org.jdom.output.Format;
import org.jdom.output.XMLOutputter;

import controler.Controler;

public class Alerte {
	public static final byte FILE_VERSION = 2;
	public static final String APP_VERSION = "Version du 2 juin 2023";
	public static String soundName = "reveil.wav";
	public static boolean quitConfirm = true;
	
    public static void main(String[] args) {
    	readPreferences();
        Controler controler = new Controler();
    	AlarmList alarms = new AlarmList();
    	controler.setModel(alarms);
        AlarmListFrame frame = new AlarmListFrame(alarms, controler);
        controler.setView(frame);
        frame.setVisible(true);
        controler.start();
    }
    
    private static void writePreferences() {
    	Element root = new Element("xml");

    	org.jdom.Document document = new Document(root);
    	Element prefs = new Element("preferences");
    	root.addContent(prefs);
    	Element sound = new Element("son");
    	prefs.addContent(sound);
    	sound.setText(soundName);
    	Element confirm = new Element("confirm");
    	prefs.addContent(confirm);
    	confirm.setText(quitConfirm ? "Oui" : "Non");
    	try {	       
    		XMLOutputter out = new XMLOutputter(Format.getPrettyFormat());
    		out.output(document, new FileOutputStream("preferences.xml"));
    	} catch (java.io.IOException e){
    		System.out.println("Erreur à la création du fichier de préférences !");
    	}
    }

    private static void readPreferences() {
    	org.jdom.Document document;
        SAXBuilder sxb = new SAXBuilder();
        try {
           document = sxb.build(new File("preferences.xml"));
           showPreferences(document.getRootElement().getChild("preferences"));
        } catch(Exception e){
        	System.out.println("Erreur à la lecture des préférences -> création d'un fichier de préférences...");
        	writePreferences();
        }
    }
    
    @SuppressWarnings("unchecked")
	private static void showPreferences(Element root) {
        List<Element> prefsList = root.getChildren();
        for(Element e : prefsList) {
           System.out.println(e.getName() + " " + e.getText());
        }
     }
}
