package view;

import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.ActionEvent;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.KeyStroke;

import controler.Controler;
import static java.awt.event.InputEvent.CTRL_DOWN_MASK;

@SuppressWarnings("serial")
public class MenuBar extends JMenuBar {
    private JMenuItem saveItem;
    private JMenuItem undoItem;
    private JMenuItem modifyItem;
    private JMenuItem deleteItem;
    private Controler controler;
    public MenuBar(Controler c, DeleteCommand delete, ModifyCommand modify)  {
        super();
        controler = c;
        JMenu menu;
        JMenuItem item;

        menu = new JMenu("Alerte");
        add(menu);
        item = new JMenuItem("A propos...");
        item.addActionListener((ActionEvent e) -> controler.about());
        menu.add(item);
        menu.addSeparator();
        item = new JMenuItem("Quitter");
        item.setAccelerator(KeyStroke.getKeyStroke('Q', CTRL_DOWN_MASK));
        item.addActionListener((ActionEvent e) -> controler.quit());
        menu.add(item);
        
        menu = new JMenu("Alarmes");
        add(menu);
        item = new JMenuItem("Ouvrir...");
        item.addActionListener((ActionEvent e) -> controler.loadAlarms());
        menu.add(item);
        item = new JMenuItem("Enregistrer");
        item.setEnabled(false);
        saveItem = item;
        item.addActionListener((ActionEvent e) -> controler.saveAlarms());
        menu.add(item);
        item = new JMenuItem("Enregistrer sous...");
        item.addActionListener((ActionEvent e) -> controler.saveAlarmsAs());
        menu.add(item);
        
        menu = new JMenu("Edition");
        add(menu);
        item = new JMenuItem("Nouvelle alarme");
        item.addActionListener((ActionEvent e) -> controler.newAlarm());
        menu.add(item);
        menu.addSeparator();
        item = new JMenuItem("Modifier");
        //item.setAccelerator(KeyStroke.getKeyStroke("ctrl M"));
        item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, CTRL_DOWN_MASK));
        modifyItem = item;
        item.setEnabled(false);
        item.addActionListener(modify);
        menu.add(item);
        item = new JMenuItem("Supprimer");
        //item.setAccelerator(KeyStroke.getKeyStroke("ctrl DELETE"));
        item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_DELETE, CTRL_DOWN_MASK));
        deleteItem = item;
        item.setEnabled(false);
        item.addActionListener(delete);
        menu.add(item);
        menu.addSeparator();
        item = new JMenuItem("Annuler");
        item.setAccelerator(KeyStroke.getKeyStroke('Z', CTRL_DOWN_MASK));
        item.setEnabled(false);
        undoItem = item;
        item.addActionListener((ActionEvent e) -> controler.undo());
        menu.add(item);
    }
    public void allowSaveItem(boolean b) {
    	saveItem.setEnabled(b);
    }
    public void allowUndoItem(boolean b) {
    	undoItem.setEnabled(b);
    }
    public void allowModifyDeleteItems(boolean b) {
    	modifyItem.setEnabled(b);
    	deleteItem.setEnabled(b);
    }
}
